'use strict';

// ------------------------------------------------------------------------------
// Requirements
// ------------------------------------------------------------------------------

let rule = require('../../../lib/rules/string-matching-prohibited');

let RuleTester = require('eslint').RuleTester;

// ------------------------------------------------------------------------------
// Tests
// ------------------------------------------------------------------------------

let ruleTester = new RuleTester({
    parserOptions: {
        ecmaVersion: 10,
    },
});

ruleTester.run('string-matching-prohibited', rule, {

    valid: [ // 合法示例
        '_.time({a:1});',
        "_.time('abc');",
        "_.time(['a', 'b', 'c']);",
        "lodash.time('abc');",
        'lodash.time({a:1});',
        'abc.time',
        "lodash.time(['a', 'b', 'c']);",
    ],

    invalid: [ // 不合法示例
        {
            code: 'let b = {a:"mo" }',
            options: [["mola", "mo"]], // 将配置作为数组的第一项传递
            errors: [{
              message: '出现违规字符/字符组', // 与rule抛出的错误保持一致
              type: "Literal", // rule监听的对应钩子
              // messageId: 'unexpectedLiteral',//与rule抛出对应错误id保持一致
            }]
        },
        {
            code: "let a = 'mola'",
            options: [["mola", "mo"]], // 将配置作为数组的第一项传递
            errors: [{
              message: '出现违规字符/字符组', // 与rule抛出的错误保持一致
              type: "Literal", // rule监听的对应钩子
              // messageId: 'unexpectedLiteral',//与rule抛出对应错误id保持一致
            }]
        },
        {
          code: "let a = function(){ return 'mola' }",
          options: [["mola", "mo"]], // 将配置作为数组的第一项传递
          errors: [{
            message: '出现违规字符/字符组', // 与rule抛出的错误保持一致
            type: "Literal", // rule监听的对应钩子
            // messageId: 'unexpectedLiteral',//与rule抛出对应错误id保持一致
          }]
        },
        {
          code: 'let b = {a:{ q : "mola"} }',
          options: [["mola", "mo"]], // 将配置作为数组的第一项传递
          errors: [{
            message: '出现违规字符/字符组', // 与rule抛出的错误保持一致
            type: "Literal", // rule监听的对应钩子
            // messageId: 'unexpectedLiteral',//与rule抛出对应错误id保持一致
          }]
        },
    ],
});

